package com.srs.dormitory;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.generator.FastAutoGenerator;
import com.baomidou.mybatisplus.generator.config.OutputFile;
import com.baomidou.mybatisplus.generator.config.TemplateConfig;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;
import com.baomidou.mybatisplus.generator.fill.Property;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.function.Consumer;

public class UserGenerator {
    public static void main(String[] args) {
        List<String> tables = new ArrayList<>();
//        tables.add("dms_campus");
//        tables.add("dms_dormitory_bed");
//        tables.add("dms_dormitory");
//        tables.add("dms_dormitory_unit");
//        tables.add("dms_dormitory_building");
//        tables.add("dms_dormitory_building_info");
//        tables.add("dms_dormitory_floor");
//        tables.add("dms_dormitory_good");
//        tables.add("dms_photos");
//        tables.add("dms_repair_status");
//        tables.add("dms_repair_records");
//        tables.add("dms_dormitory_dept");
        tables.add("dms_dept_grade");
        FastAutoGenerator.create("jdbc:" +
                        "mysql://124.70.202.11:3306/srs", "eta", "Eta123456@")
                .globalConfig(builder -> {
                    builder
                            .author("猪油骨")//作者
                            .outputDir("F:\\srs\\srs-java\\dms-dormitory\\src\\main\\java")    //输出路径(写到java目录)
                            .enableSwagger()           //开启swagger
                            .commentDate("yyyy-MM-dd");

                })
                .packageConfig(builder -> {
                    builder.parent("com.srs")
                            .moduleName("dormitory")
                            .entity("domain")
                            .service("service")
                            .serviceImpl("service.impl")
                            .controller("controller")
                            .mapper("mapper")
                            .xml("dormitory")
                            .pathInfo(Collections.singletonMap(OutputFile.xml, "F:\\srs\\srs-java\\dms-dormitory\\src\\main\\resources\\mapper\\dormitory"));
                })
                .strategyConfig(builder -> {
                    builder.addInclude(tables)
                            .serviceBuilder()
                            .formatServiceFileName("I%sService")
                            .formatServiceImplFileName("I%sServiceImpl")
                            .entityBuilder()
                            .enableLombok()
                            .logicDeleteColumnName("delFlag")
                            .idType(IdType.AUTO)
                            .enableTableFieldAnnotation()
                            .addTableFills(new Property("createTime", FieldFill.INSERT))
                            .addTableFills(new Property("updateTime", FieldFill.INSERT_UPDATE))
                            .controllerBuilder()
                            // 映射路径使用连字符格式，而不是驼峰
                            .enableHyphenStyle()
                            .formatFileName("%sController")
                            .enableRestStyle()
                            .mapperBuilder()
                            //生成通用的resultMap
                            .enableBaseResultMap()
                            .superClass(BaseMapper.class)
                            .formatMapperFileName("%sMapper")
                            .enableFileOverride()
                            .formatXmlFileName("%sMapper");
                })
                .templateConfig(new Consumer<TemplateConfig.Builder>() {
                    @Override
                    public void accept(TemplateConfig.Builder builder) {
                        // 实体类使用我们自定义模板
                        builder.entity("templates/myentity.java");
                    }
                })
                .templateEngine(new FreemarkerTemplateEngine()) // 使用Freemarker引擎模板，默认的是Velocity引擎模板
                .execute();
    }
}

